part of 'package:zego_uikit_prebuilt_live_audio_room/src/controller.dart';

/// @nodoc
mixin ZegoLiveAudioRoomControllerRoom {
  final _roomImpl = ZegoAudioRoomControllerRoomImpl();

  ZegoAudioRoomControllerRoomImpl get room => _roomImpl;
}

/// Here are the APIs related to screen sharing.
class ZegoAudioRoomControllerRoomImpl
    with ZegoAudioRoomControllerRoomImplPrivate {
  Stream<ZegoUIKitReceiveSEIEvent> seiStream() {
    return ZegoUIKit().getReceiveCustomSEIStream();
  }

  Future<bool> sendSEI(
    Map<String, dynamic> seiData, {
    ZegoStreamType streamType = ZegoStreamType.main,
  }) async {
    final localSeatIndex =
        private.seatManager?.getIndexByUserID(ZegoUIKit().getLocalUser().id) ??
            -1;
    if (-1 == localSeatIndex) {
      ZegoLoggerService.logInfo(
        'local is not on seat, could not sed SEI',
        tag: 'audio room',
        subTag: 'controller.room',
      );
      return false;
    }

    return ZegoUIKit().sendCustomSEI(
      seiData,
      streamType: streamType,
    );
  }
}
